#include <set>
#include "oniguruma.h"
#include "expat.h"

#include "File.h"
#include "Value.h"
#include "Codec.h"
#include "Codec_Japanese.h"

#define NUMBEROF(x) (sizeof(x) / sizeof(x[0]))
#define foreach(T, i, c) for (T::iterator i = (c).begin(); i != (c).end(); i++)

using namespace AScript;

main()
{
	static const struct {
		const char *str;
		int len;
	} tbl[] = {
		{ "ABCDEFG", 7 },
		{ "\x14\xfb\x9c\x03\xd9\x7e", 6 },
		{ "\x14\xfb\x9c\x03\xd9", 5 },
		{ "\x14\xfb\x9c\x03", 4 },
	};
	String str1, str2;
	for (int i = 0; i < NUMBEROF(tbl); i++) {
		str1.clear(), str2.clear();
		Codec_Encoder_Base64(true).Convert(str1, tbl[i].str, tbl[i].len);
		::printf("%s\n", str1.c_str());
		Codec_Decoder_Base64(true).Convert(str2, str1.c_str());
		foreach (String, p, str2) {
			::printf("\\x%02x", static_cast<unsigned char>(*p));
		}
		::printf("\n");
	}
}

#if 0
main()
{
	char *str = "ɂ͐E@鳖\n";
	//char *str = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	//char *str = "";
	//printf("\xef\xbb\xbf");
	String buff1, buff2;
	Codec_Decoder_CP932(true).Convert(buff1, str);
	//printf("%s", buff1.c_str());
	Codec_Encoder_CP932(true).Convert(buff2, buff1.c_str());
	printf("%s", buff2.c_str());
	return 0;
}
#endif

#if 0
main()
{
	::printf("IsSJISFirst()\n");
	for (int ch = 0; ch < 256; ch++) {
		if (IsSJISFirst(ch)) ::printf("%c(%02x)", ch, ch);
	}
	::printf("\n");
	::printf("IsSJISSecond()\n");
	for (int ch = 0; ch < 256; ch++) {
		if (IsSJISSecond(ch)) ::printf("%c(%02x)", ch, ch);
	}
	::printf("\n");
	::printf("IsDigit()\n");
	for (int ch = 0; ch < 256; ch++) {
		if (IsDigit(ch)) ::printf("%c(%02x)", ch, ch);
	}
	::printf("\n");
	::printf("IsHexDigit()\n");
	for (int ch = 0; ch < 256; ch++) {
		if (IsHexDigit(ch)) ::printf("%c(%02x)", ch, ch);
	}
	::printf("\n");
	::printf("IsOctDigit()\n");
	for (int ch = 0; ch < 256; ch++) {
		if (IsOctDigit(ch)) ::printf("%c(%02x)", ch, ch);
	}
	::printf("\n");
	::printf("IsWhite()\n");
	for (int ch = 0; ch < 256; ch++) {
		if (IsWhite(ch)) ::printf("%c(%02x)", ch, ch);
	}
	::printf("\n");
	::printf("IsSpace()\n");
	for (int ch = 0; ch < 256; ch++) {
		if (IsSpace(ch)) ::printf("%c(%02x)", ch, ch);
	}
	::printf("\n");
	::printf("IsSymbolFirstChar()\n");
	for (int ch = 0; ch < 256; ch++) {
		if (IsSymbolFirstChar(ch)) ::printf("%c(%02x)", ch, ch);
	}
	::printf("\n");
	::printf("IsSymbolChar()\n");
	for (int ch = 0; ch < 256; ch++) {
		if (IsSymbolChar(ch)) ::printf("%c(%02x)", ch, ch);
	}
	::printf("\n");
}
#endif

#if 0
main()
{
	::printf("%s\n", File::GetWorkingDir());
	::printf("%s\n", File::MakeAbsPath("Scratch.cpp").c_str());
	::printf("%s\n", File::MakeAbsPath("\\Scratch.cpp").c_str());
	::printf("%s\n", File::MakeAbsPath("..\\Scratch.cpp").c_str());
	::printf("%s\n", File::MakeAbsPath("..\\..\\Scratch.cpp").c_str());
	::printf("%s\n", File::MakeAbsPath("..\\..\\..\\Scratch.cpp").c_str());
	::printf("%s\n", File::MakeAbsPath("..\\..\\..\\..\\Scratch.cpp").c_str());
	::printf("%s\n", File::MakeAbsPath(
			"..\\..\\..\\..\\..\\..\\..\\..\\..\\Scratch.cpp").c_str());
	::printf("%s\n", File::MakeAbsPath("hoge.txt", "C:\\hoge").c_str());
	::printf("%s\n", File::MakeAbsPath("hoge.txt", "C:\\hoge\\").c_str());
}
#endif

#if 0
main()
{
	do {
		int count = 6;
		int dec, sign;
		double value = 523456789.123456789;
		char *p = ::_ecvt(value, count, &dec, &sign);
		::printf("_ecvt .. %s count=%d,dec=%d,sign=%d\n", p, count, dec, sign);
	} while (0);
	do {
		int count = 6;
		int dec, sign;
		double value = -523456789.123456789;
		char *p = ::_ecvt(value, count, &dec, &sign);
		::printf("_ecvt .. %s count=%d,dec=%d,sign=%d\n", p, count, dec, sign);
	} while (0);
	do {
		int count = 10;
		int dec, sign;
		double value = 52345.89;
		char *p = ::_ecvt(value, count, &dec, &sign);
		::printf("_ecvt .. %s count=%d,dec=%d,sign=%d\n", p, count, dec, sign);
	} while (0);
	do {
		int count = 6;
		int dec, sign;
		double value = 0.000523456789;
		char *p = ::_ecvt(value, count, &dec, &sign);
		::printf("_ecvt .. %s count=%d,dec=%d,sign=%d\n", p, count, dec, sign);
	} while (0);
	do {
		int count = 6;
		int dec, sign;
		double value = 0.523456789;
		char *p = ::_ecvt(value, count, &dec, &sign);
		::printf("_ecvt .. %s count=%d,dec=%d,sign=%d\n", p, count, dec, sign);
	} while (0);
	do {
		int count = 6;
		int dec, sign;
		double value = 523456789.123456789;
		char *p = ::_fcvt(value, count, &dec, &sign);
		::printf("_fcvt .. %s count=%d,dec=%d,sign=%d\n", p, count, dec, sign);
	} while (0);
	do {
		int count = 6;
		int dec, sign;
		double value = 0.000523456789;
		char *p = ::_fcvt(value, count, &dec, &sign);
		::printf("_fcvt .. %s count=%d,dec=%d,sign=%d\n", p, count, dec, sign);
	} while (0);
	do {
		int count = 6;
		int dec, sign;
		double value = 0.523456789;
		char *p = ::_fcvt(value, count, &dec, &sign);
		::printf("_fcvt .. %s count=%d,dec=%d,sign=%d\n", p, count, dec, sign);
	} while (0);
	do {
		int count = 10;
		int dec, sign;
		double value = 52345.89;
		char *p = ::_fcvt(value, count, &dec, &sign);
		::printf("_fcvt .. %s count=%d,dec=%d,sign=%d\n", p, count, dec, sign);
	} while (0);
	do {
		int digits = 1;
		char buff[128];
		double value = 523456789.123456789;
		char *p = ::_gcvt(value, digits, buff);
		::printf("_gcvt .. %s digits=%d\n", p, digits);
	} while (0);
	do {
		int digits = 6;
		char buff[128];
		double value = 523456789.123456789;
		char *p = ::_gcvt(value, digits, buff);
		::printf("_gcvt .. %s digits=%d\n", p, digits);
	} while (0);
	do {
		int digits = 6;
		char buff[128];
		double value = 5239.123456789;
		char *p = ::_gcvt(value, digits, buff);
		::printf("_gcvt .. %s digits=%d\n", p, digits);
	} while (0);
}
#endif

#if 0
int onigFunc(const UChar *nameRaw, const UChar *nameRawEnd, int nGroups, int *idxGroupTbl, regex_t *pRegEx, void *arg)
{
	String name(reinterpret_cast<const char *>(nameRaw), nameRawEnd - nameRaw);
	::printf("\"%s\" .. ", name.c_str());
	for (int i = 0; i < nGroups; i++) {
		::printf(" %d", idxGroupTbl[i]);
	}
	::printf("\n");
	return 0;
}

int main(int argc, char *argv[])
{
	//char *pattern = "a(.*)b|[e-f]+";
	const char *pattern = "(?<func>\\w+)\\((?<arg>\\w+)(?<arg>\\w+)(?<arg>\\w+)(?<ex>\\w+)";
	regex_t *pRegEx = NULL;
	do {
		OnigErrorInfo errInfo;
		size_t len = ::strlen(pattern);
		int rtn = ::onig_new(&pRegEx, pattern, pattern + len,
			ONIG_OPTION_DEFAULT, ONIG_ENCODING_ASCII, ONIG_SYNTAX_DEFAULT, &errInfo);
		if (rtn != ONIG_NORMAL) {
			char errMsg[ONIG_MAX_ERROR_MESSAGE_LEN];
			::onig_error_code_to_str(errMsg, rtn, &errInfo);
			::fprintf(stderr, "ERROR: %s\n", errMsg);
			return 1;
		}
		::onig_foreach_name(pRegEx, &onigFunc, NULL);
	} while (0);
	do {
		//char *str = "zzzzaffffffffb";
		const char *str = "int main(int argc, char *argv[])";
		size_t len = ::strlen(str);
		const char *start = str;
		OnigRegion *pRegion = ::onig_region_new();
		int rtn = ::onig_search(pRegEx, str, str + len, start, start + len,
												pRegion, ONIG_OPTION_NONE);
		if (rtn >= 0) {
			::fprintf(stderr, "match at position %d\n", rtn);
			for (int iGroup = 0; iGroup < pRegion->num_regs; iGroup++) {
				int posBegin = pRegion->beg[iGroup];
				int posEnd = pRegion->end[iGroup];
				::fprintf(stderr, "group#%d: position %2d-%2d \"%s\"\n",
						iGroup, posBegin, posEnd,
						String(str + posBegin, posEnd - posBegin).c_str());
			}
		} else if (rtn == ONIG_MISMATCH) {
			::fprintf(stderr, "matching failed\n");
		} else { // error
			char errMsg[ONIG_MAX_ERROR_MESSAGE_LEN];
			::onig_error_code_to_str(errMsg, rtn);
			::fprintf(stderr, "ERROR: %s\n", errMsg);
			return -1;
		}
		::onig_region_free(pRegion, 1); // 1:free self, 0:free contents only
	} while (0);
	::onig_free(pRegEx);
	::onig_end();
	return 0;
}
#endif

#if 0
static void XMLCALL startElement(void *userData, const char *name, const char **attrs)
{
	int &depth = *reinterpret_cast<int *>(userData);
	::printf("%*s%s\n", depth * 4, "", name);
	depth++;
}

static void XMLCALL endElement(void *userData, const char *name)
{
	int &depth = *reinterpret_cast<int *>(userData);
	depth--;
}

int main(int argc, char *argv[])
{
	int depth = 0;
	char buff[BUFSIZ];
	XML_Parser parser = ::XML_ParserCreate(NULL);
	::XML_SetUserData(parser, &depth);
	::XML_SetElementHandler(parser, startElement, endElement);
	for (;;) {
		int bytes = ::fread(buff, 1, sizeof(buff), stdin);
		int doneFlag = (bytes < sizeof(buff));
		if (::XML_Parse(parser, buff, bytes, doneFlag) == XML_STATUS_ERROR) {
			::fprintf(stderr, "%s at line %lu\n",
					::XML_ErrorString(XML_GetErrorCode(parser)),
					::XML_GetCurrentLineNumber(parser));
			break;
		}
		if (doneFlag) break;
	}
	::XML_ParserFree(parser);
	return 0;
}
#endif

#if 0
void main()
{
	printf("%d\n", File::IsMatchName("*.asm", "test.txt", false));
}
#endif

#if 0
main()
{
	std::auto_ptr<FileLister> pFileLister(FileLister::CreateInstance("."));
	FileEntry entry;
	while (pFileLister->Next(entry)) {
		::printf("%s\n", entry.GetFileName());
	}
}
#endif

#if 0
main()
{
	char *str = "ɂ͐E@鳖鲁@̃R[hӖƂ́A[łP𕪊Ȃ󔒕ƂƂłA܂艽@\ȂƂĈB";
	printf("\xff\xfe");
	for ( ; *str != '\0'; str += 2) {
		unsigned short codeSJIS =
			(static_cast<unsigned short>(static_cast<unsigned char>(*str)) << 8) +
			static_cast<unsigned char>(*(str + 1));
		unsigned short codeUTF16 = CP932ToUTF16(codeSJIS);
		printf("%c%c", codeUTF16 & 0xff, (codeUTF16 >> 8) & 0xff);
	}
}
#endif
